// ___SETA43  _____
// IRemisorv1SETA
//Mando Infrarojo EMISOR _____
//OUT  (salida) -Led infrarojo PIN 3  arduino uno
//02/10/2019



int pulsador;

void setup() 
{
  Serial.begin(9600);
 
  pinMode(4, OUTPUT); pinMode(5, OUTPUT);pinMode(6, OUTPUT);pinMode(7, OUTPUT);
  pinMode(8, INPUT); pinMode(9, INPUT); pinMode(10, INPUT); pinMode(11, INPUT);
  Serial.println("Empieza Emisor IR seta");
  delay(500);

}

void loop() 
{
  pulsador=getTeclado();

    if(pulsador!=0) 
      {
        Serial.print("TECLA="); Serial.println(pulsador);
        switch(pulsador)
        {
          case 10:
            pulsador=0;
          break;
          case 13:
            pulsador=16;
          break;
          case 14:
            pulsador=17;
          break;
          case 15:
            pulsador=32;
          break;
          case 16:
            pulsador=33;
          break;         
        }
        if(pulsador==10) pulsador=0;
        Serial.print("SEND_IR=");Serial.println(pulsador);
        sendRC5(pulsador, 12);
        delay(90);
        sendRC5(pulsador, 12);
        delay(90);
      }
    
  delay(1);

}


int getTeclado(void)
{
 int z;
    z=0;
    digitalWrite(7, HIGH);
    delay(10);
    if(1==digitalRead(8)) { z=1; while(1==digitalRead(8)) delay(1);}
    if(1==digitalRead(9)) { z=2; while(1==digitalRead(9)) delay(1);}
    if(1==digitalRead(10)) { z=3; while(1==digitalRead(10)) delay(1);}
    if(1==digitalRead(11)) { z=4; while(1==digitalRead(11)) delay(1);}
    digitalWrite(7, LOW);

    digitalWrite(6, HIGH);
    delay(10);
    if(1==digitalRead(8)) { z=5; while(1==digitalRead(8)) delay(1);}
    if(1==digitalRead(9)) { z=6; while(1==digitalRead(9)) delay(1);}
    if(1==digitalRead(10)) { z=7; while(1==digitalRead(10)) delay(1);}
    if(1==digitalRead(11)) {z=8; while(1==digitalRead(11)) delay(1);}
    digitalWrite(6, LOW);

    digitalWrite(5, HIGH);
    delay(10);
    if(1==digitalRead(8)) { z=9; while(1==digitalRead(8)) delay(1);}
    if(1==digitalRead(9)) { z=10; while(1==digitalRead(9)) delay(1);}
    if(1==digitalRead(10)) { z=11; while(1==digitalRead(10)) delay(1);}
    if(1==digitalRead(11)) { z=12; while(1==digitalRead(11)) delay(1);}
    digitalWrite(5, LOW);

    digitalWrite(4, HIGH);
    delay(10);
    if(1==digitalRead(8)) { z=13; while(1==digitalRead(8)) delay(1);}
    if(1==digitalRead(9)) { z=14; while(1==digitalRead(9)) delay(1);}
    if(1==digitalRead(10)) { z=15; while(1==digitalRead(10)) delay(1);}
    if(1==digitalRead(11)) { z=16; while(1==digitalRead(11)) delay(1);}
    digitalWrite(4, LOW);
     return(z);
}





//___________________________Rutinas de IRemote_______________________________________________________


#define SYSCLOCK  16000000

//+=============================================================================
// Custom delay function that circumvents Arduino's delayMicroseconds limit

void custom_delay_usec(unsigned long uSecs) {
  if (uSecs > 4) {
    unsigned long start = micros();
    unsigned long endMicros = start + uSecs - 4;
    if (endMicros < start) { // Check if overflow
      while ( micros() > start ) {} // wait until overflow
    }
    while ( micros() < endMicros ) {} // normal wait
  } 
  //else {
  //  __asm__("nop\n\t"); // must have or compiler optimizes out
  //}
}




#define TIMER_ENABLE_PWM    (TCCR2A |= _BV(COM2B1))
#define TIMER_DISABLE_PWM   (TCCR2A &= ~(_BV(COM2B1)))
#define TIMER_ENABLE_INTR   (TIMSK2 = _BV(OCIE2A))
#define TIMER_DISABLE_INTR  (TIMSK2 = 0)
#define TIMER_CONFIG_KHZ(val) ({ \
	const uint8_t pwmval = SYSCLOCK / 2000 / (val); \
	TCCR2A               = _BV(WGM20); \
	TCCR2B               = _BV(WGM22) | _BV(CS20); \
	OCR2A                = pwmval; \
	OCR2B                = pwmval / 3; \
})

#define TIMER_PWM_PIN  3

//+=============================================================================
// Sends an IR mark for the specified number of microseconds.
// The mark output is modulated at the PWM frequency.
//
void  mark (unsigned int time)
{
	TIMER_ENABLE_PWM; // Enable pin 3 PWM output
	if (time > 0) custom_delay_usec(time);
}

//+=============================================================================
// Leave pin off for time (given in microseconds)
// Sends an IR space for the specified number of microseconds.
// A space is no output, so the PWM output is disabled.
//
void  space (unsigned int time)
{
	TIMER_DISABLE_PWM; // Disable pin 3 PWM output
	if (time > 0) custom_delay_usec(time);
}




#define BLINKLED        3
#define BLINKLED_ON()   digitalWrite(BLINKLED, HIGH)
#define BLINKLED_OFF()  digitalWrite(BLINKLED, LOW)


#define MIN_RC5_SAMPLES     11
#define RC5_T1            790 // 889
#define RC5_RPT_LENGTH   46000


void  sendRC5 (unsigned long data,  int nbits)
{
  // Set IR carrier frequency
  enableIROut(36);

  // Start
  mark(RC5_T1);
  space(RC5_T1);
  mark(RC5_T1);

  // Data
  for (unsigned long  mask = 1UL << (nbits - 1);  mask;  mask >>= 1) {
    if (data & mask) {
      space(RC5_T1); // 1 is space, then mark
      mark(RC5_T1);
    } else {
      mark(RC5_T1);
      space(RC5_T1);
    }
  }

  space(0);  // Always end with the LED off
}



void  enableIROut (int khz)
{
  // Disable the Timer2 Interrupt (which is used for receiving IR)
  TIMER_DISABLE_INTR; //Timer2 Overflow Interrupt

  pinMode(TIMER_PWM_PIN, OUTPUT);
  digitalWrite(TIMER_PWM_PIN, LOW); // When not sending PWM, we want it low

  // COM2A = 00: disconnect OC2A
  // COM2B = 00: disconnect OC2B; to send signal set to 10: OC2B non-inverted
  // WGM2 = 101: phase-correct PWM with OCRA as top
  // CS2  = 000: no prescaling
  // The top value for the timer.  The modulation frequency will be SYSCLOCK / 2 / OCR2A.
  TIMER_CONFIG_KHZ(khz);

}
